- Rust 99.9%
| Filename | Latest commit message | Latest commit date |
|---|---|---|
This provides a clear and consistent interface for selecting TLS-related
features on both (xmpp and tokio-xmpp) crates. All feature checks have
been revamped. All working combinations have been tested (including a
connectivity test + --all-features docs build) using:
```
set -xeuo pipefail
features=(aws_lc_rs ring ktls,aws_lc_rs ktls,ring aws_lc_rs,ring aws_lc_rs,ring,ktls native-tls rustls-any-backend)
export RUSTFLAGS=" -D warnings"
cargo test --no-default-features
cargo test
for feature in ${features[@]}; do
echo ">>> BUILDING with $feature" 2>&1
# Running code or building examples cannot succeed with rustls-any-backend.
features="starttls,$feature"
if [ "$feature" != 'rustls-any-backend' ]; then
if ! cargo test --no-default-features --features="$features"; then
echo ">>> BUILD FAILED for tls feature set: $features" >&2
exit 1
fi
set +e
timeout -sINT -p -k 2 3 cargo run --no-default-features --features="$features" --example keep_connection -- test@hub.sotecware.net "$(pass xmpp/test@hub.sotecware.net)"
status="$?"
set -e
if [ $status -ne 0 ]; then
echo ">>> keep_connection did not shut down cleanly! (status: $status)" >&2
exit 1
fi
else
if ! cargo build --no-default-features --features="$feature"; then
echo ">>> BUILD FAILED for tls feature set: $features" >&2
exit 1
fi
fi
done
RUSTDOCFLAGS="--cfg docsrs" RUSTFLAGS="--cfg xmpprs_doc_build" cargo +nightly doc -Zrustdoc-map --all-features
```
|
||
| .forgejo/workflows | ||
| jid | ||
| minidom | ||
| parsers | ||
| sasl | ||
| tokio-xmpp | ||
| xmpp | ||
| xso | ||
| xso-proc | ||
| .gitea | ||
| .github | ||
| .gitignore | ||
| .gitlab-ci.yml | ||
| Cargo.toml | ||
| CODE_OF_CONDUCT.md | ||
| CONTRIBUTING.md | ||
| LICENSE | ||
| README.md | ||
xmpp-rs
What's this?
A very much WIP set of rust XMPP library with the goals of being type-safe and well-tested.
xmpp-rsprovides a high-level API for the protocol. You shouldn't need to know about the protocol to use it.tokio-xmppis a lower-level library that handles the XMPP stream(s).xmpp-parsersparses XML into Rust and back.minidomis a DOM library quite specific for XMPPjidis a Jid parsing library.
Contact
There is an XMPP MUC for the discussion of this library, feel free to join! :)
Community
A Code of Conduct is available as CODE_OF_CONDUCT.md in the repository for the well-being of the community. Please refer to it in case of a possible conflict in any of the xmpp-rs venues (channel, forge, etc.).
License
Mozilla Public License 2 (MPL2). See the LICENSE file.
Building
Dependencies should be provided by crates if you use the default features. If
you use tokio-xmpp's tls-native feature you will need an ssl library
(openssl, libressl, etc.).
cargo build
The various features available should be explained in the crates themselves.
Contributing
Thank you for your interest in the project!
Contributing rules are available as CONTRIBUTING.md in the repository.